diff -uNrd -x CVS ircd-hybrid-7rc5/iauth/source/sock.c ircd-hybrid-7-bg/iauth/source/sock.c
--- ircd-hybrid-7rc5/iauth/source/sock.c	Thu Jan 10 15:45:13 2002
+++ ircd-hybrid-7-bg/iauth/source/sock.c	Mon Dec 30 23:07:25 2002
@@ -15,7 +15,7 @@
  *   along with this program; if not, write to the Free Software
  *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  *
- *   $Id: sock.c,v 7.10 2002/01/10 20:45:13 jmallett Exp $
+ *   $Id: sock.c,v 1.1.1.1 2002/12/31 04:07:25 demond Exp $
  */
 
 #include <stdio.h>
diff -uNrd -x CVS ircd-hybrid-7rc5/include/balloc.h ircd-hybrid-7-bg/include/balloc.h
--- ircd-hybrid-7rc5/include/balloc.h	Fri Jul 12 12:14:04 2002
+++ ircd-hybrid-7-bg/include/balloc.h	Mon Dec 30 23:07:25 2002
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: balloc.h,v 1.12 2002/07/12 16:14:04 androsyn Exp $
+ *  $Id: balloc.h,v 1.1.1.1 2002/12/31 04:07:25 demond Exp $
  */
 
 #ifndef INCLUDED_blalloc_h
diff -uNrd -x CVS ircd-hybrid-7rc5/include/channel.h ircd-hybrid-7-bg/include/channel.h
--- ircd-hybrid-7rc5/include/channel.h	Mon Oct 28 16:09:20 2002
+++ ircd-hybrid-7-bg/include/channel.h	Mon Mar 10 01:09:00 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: channel.h,v 7.120 2002/10/28 21:09:20 bill Exp $
+ *  $Id: channel.h,v 1.2 2003/03/10 06:09:00 demond Exp $
  */
 
 #ifndef INCLUDED_channel_h
@@ -43,6 +43,22 @@
   char  key[KEYLEN];
 };
 
+/* used for pacing JOINs, PARTs and PRIVMSGs/NOTICEs to channel
+ *                                                     -demond
+ */
+struct Pace
+{
+  struct Pace *next;
+  int shownames;            /* if nonzero, show names to client on JOIN */
+                            /* buffer len on NICK/QUIT notification */
+  char *text;               /* message text on chanmsg */
+                            /* send buffer on NICK/QUIT notification */
+  char nick[NICKLEN+1];     /* nick-originator on JOIN/PART or "command" */
+  char user[HOSTLEN+1];     /* username on JOIN/PART or "butone" on chanmsg */
+  char host[HOSTLEN+1];     /* host on JOIN/PART or originator on chanmsg */
+  char chan[1];
+};
+
 /* channel structure */
 
 struct Channel
@@ -86,19 +102,30 @@
 #endif
   dlink_list      locvoiced;
   dlink_list      locpeons;             /* ... */
-  
+
   dlink_list      invites;
   dlink_list      banlist;
   dlink_list      exceptlist;
   dlink_list      invexlist;
+  dlink_list      denylist;				/* gecos & channame deny list */
+
+  dlink_list      substlist;            /* word substitutions list */
 
   time_t          first_received_message_time; /* channel flood control */
   int             received_number_of_privmsgs;
   int             flood_noticed;
 
-  int             num_mask;              /* number of bans+exceptions+invite exceptions */
+  int             num_mask;             /* number of bans+exceptions+invite exceptions */
   time_t          channelts;
   char            chname[CHANNELLEN+1];
+
+  struct Pace     *joinh, *joint;       /* pace JOIN list head, tail */
+  struct Pace     *parth, *partt;       /* pace PART list head, tail */
+  int             joins, parts;         /* pace counters */
+
+  struct Pace     *msgh, *msgt;         /* pace chanmsg list head, tail */
+  struct Pace     *sendh, *sendt;       /* pace NICK/QUIT list head, tail */
+  int             msgs, sends;          /* pace counters */
 };
 
 extern  struct  Channel *GlobalChannelList;
@@ -106,6 +133,7 @@
 void init_channels(void);
 void cleanup_channels(void *);
 
+void pace_channels(void *);
 
 extern int     can_send (struct Channel *chptr, struct Client *who);
 extern int     is_banned (struct Channel *chptr, struct Client *who);
@@ -148,6 +176,11 @@
 
 extern void check_splitmode(void *);
 
+extern void add_pace(struct Channel *, struct Client *, char *, int, int);
+extern void add_pace_msg(struct Channel *, struct Client *, struct Client *, char *, char *);
+extern void add_pace_send(struct Channel *, char *, int);
+extern void sendto_chanlists_local(struct Channel *, char *, int);
+
 /*
 ** Channel Related macros follow
 */
@@ -161,15 +194,17 @@
 
 #define IsChannelName(name) ((name) && (*(name) == '#' || *(name) == '&'))
 
-struct Ban          /* also used for exceptions -orabidoo */
+struct Ban          						/* also used for exceptions -orabidoo */
 {
   char *banstr;
   char *who;
   time_t when;
 };
 
-#define CLEANUP_CHANNELS_TIME (30*60)
-#define MAX_VCHAN_TIME (60*60)
+#define CLEANUP_CHANNELS_TIME	(30*60)
+#define MAX_VCHAN_TIME			(60*60)
+#define PACE_CHANNELS_TIME		1           /* pace queue flush frequency */
+
 /* Number of chanops, peon, voiced, halfops sublists */
 #ifdef REQUIRE_OANDV
 #define NUMLISTS 5
@@ -181,8 +216,28 @@
 void do_channel_integrity_check(void);
 #endif
 
-void set_channel_topic(struct Channel *chptr, const char *topic, const char *topic_info, time_t topicts); 
+void set_channel_topic(struct Channel *chptr, const char *topic, const char *topic_info, time_t topicts);
 void free_topic(struct Channel *);
 int allocate_topic(struct Channel *);
+
+#define MAX_PACEJOIN 100					/* max number of events in pace queue */
+#define MAX_PACEMSG  100
+#define MAX_PACESEND 100
+
+extern char *strip_color(const char *, int);
+
+/*
+ * we don't need this anymore...   -demond
+ *
+#define strip_color(x) if (x) {\
+    char *p = x, *q = x;\
+    if (strchr(x, '\003') || strchr(x, '\033'))\
+      do {\
+        if ((*q == '\003') || (*q == '\033'))\
+          ++q;\
+      }\
+        while (*p++ = *q++);\
+    }
+*/
 
 #endif  /* INCLUDED_channel_h */
diff -uNrd -x CVS ircd-hybrid-7rc5/include/channel_mode.h ircd-hybrid-7-bg/include/channel_mode.h
--- ircd-hybrid-7rc5/include/channel_mode.h	Mon Oct 28 16:09:20 2002
+++ ircd-hybrid-7-bg/include/channel_mode.h	Mon Mar 10 01:09:00 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: channel_mode.h,v 7.13 2002/10/28 21:09:20 bill Exp $
+ *  $Id: channel_mode.h,v 1.2 2003/03/10 06:09:00 demond Exp $
  */
 
 
@@ -44,9 +44,9 @@
 #define MODEBUFLEN      200
 
 /* Maximum mode changes allowed per client, per server is different */
-#define MAXMODEPARAMS   4
+#define MAXMODEPARAMS   6
 
-extern void    set_channel_mode(struct Client *, struct Client *, 
+extern void    set_channel_mode(struct Client *, struct Client *,
                                 struct Channel *, int, char **, char *);
 
 #ifdef ANONOPS
@@ -65,41 +65,52 @@
 */
 
 /* can_send results */
-#define CAN_SEND_NO	0
+#define CAN_SEND_NO		0
 #define CAN_SEND_NONOP  1
 #define CAN_SEND_OPV	2
-
+#define CAN_SEND_NOTREG 3      /* nonreg nicks cannot send to +M chans */
 
 /* Channel related flags */
 
-#define CHFL_PEON	0x0000 /* normal member of channel */
+#define CHFL_PEON		0x0000 /* normal member of channel */
 #define CHFL_CHANOP     0x0001 /* Channel operator */
 #define CHFL_VOICE      0x0002 /* the power to speak */
 #define CHFL_DEOPPED    0x0004 /* deopped by us, modes need to be bounced */
 #define CHFL_HALFOP     0x0008 /* Channel half op */
 #define CHFL_BAN        0x0010 /* ban channel flag */
 #define CHFL_EXCEPTION  0x0020 /* exception to ban channel flag */
+#define CHFL_SUBST		0x0040 /* word subst flag */
 #define CHFL_INVEX      0x0080
+#define CHFL_DENY       0x0100 /* gecos & channame deny flag */
 
 /* Channel Visibility macros */
 
-#define MODE_PEON	CHFL_PEON
+#define MODE_PEON		CHFL_PEON
 #define MODE_CHANOP     CHFL_CHANOP
 #define MODE_VOICE      CHFL_VOICE
-#define MODE_HALFOP	CHFL_HALFOP
+#define MODE_HALFOP		CHFL_HALFOP
 #define MODE_DEOPPED	CHFL_DEOPPED
 
 /* channel modes ONLY */
+
+#define MODE_REGCHAN    0x0001  /* channel is registered with services */
+#define MODE_REGNICKS   0x0002  /* only registered nicknames can join  */
+#define MODE_REGSPEAK	0x0004  /* only registered nicknames may speak */
 #define MODE_PRIVATE    0x0008
 #define MODE_SECRET     0x0010
 #define MODE_MODERATED  0x0020
 #define MODE_TOPICLIMIT 0x0040
 #define MODE_INVITEONLY 0x0080
 #define MODE_NOPRIVMSGS 0x0100
+#define MODE_NOCOLOR    0x0200  /* strip mIRC & ANSI color */
 #define MODE_BAN        0x0400
 #define MODE_EXCEPTION  0x0800
-#define MODE_INVEX	0x2000
+#define MODE_PACE		0x1000  /* pacing JOIN, PART, PRIVMSG and QUIT */
+#define MODE_INVEX		0x2000
 #define MODE_HIDEOPS    0x4000
+#define MODE_CYRNICKS	0x8000  /* cyrillic nicks are NOT allowed to join */
+#define MODE_NOREPEAT  0x10000  /* no public repeating allowed */
+#define MODE_SSLONLY   0x20000	/* only SSL-connected clients allowed */
 
 /*
  * mode flags which take another parameter (With PARAmeterS)
@@ -118,6 +129,16 @@
 #define ParanoidChannel(x)	((x) && ((x)->mode.mode &\
 			        (MODE_PRIVATE|MODE_INVITEONLY))==\
 		                (MODE_PRIVATE|MODE_INVITEONLY))
+
+/* colors stripped from chanmsgs, notices, ctcps, quits */
+#define NoColorChannel(x)       ((x) && ((x)->mode.mode & MODE_NOCOLOR))
+#define RegNicksOnlyChannel(x)  ((x) && ((x)->mode.mode & MODE_REGNICKS))
+#define RegsMaySpeakChannel(x)  ((x) && ((x)->mode.mode & MODE_REGSPEAK))
+#define NoCyrNicksChannel(x)    ((x) && ((x)->mode.mode & MODE_CYRNICKS))
+/* we are pacing JOINs, PARTs, PRIVMSGs and QUITs sent to the channel */
+#define PaceChannel(x)			((x) && ((x)->mode.mode & MODE_PACE))
+#define NoRepeatChannel(x)		((x) && ((x)->mode.mode & MODE_NOREPEAT))
+#define SSLonlyChannel(x)		((x) && ((x)->mode.mode & MODE_SSLONLY))
 
 struct ChModeChange
 {
diff -uNrd -x CVS ircd-hybrid-7rc5/include/class.h ircd-hybrid-7-bg/include/class.h
--- ircd-hybrid-7rc5/include/class.h	Sat Mar  9 16:48:35 2002
+++ ircd-hybrid-7-bg/include/class.h	Mon Dec 30 23:07:25 2002
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: class.h,v 7.10 2002/03/09 21:48:35 androsyn Exp $
+ *  $Id: class.h,v 1.1.1.1 2002/12/31 04:07:25 demond Exp $
  */
 
 #ifndef INCLUDED_class_h
diff -uNrd -x CVS ircd-hybrid-7rc5/include/client.h ircd-hybrid-7-bg/include/client.h
--- ircd-hybrid-7rc5/include/client.h	Wed Oct 30 12:44:53 2002
+++ ircd-hybrid-7-bg/include/client.h	Mon Mar 10 01:09:00 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: client.h,v 7.153 2002/10/30 17:44:53 wiz Exp $
+ *  $Id: client.h,v 1.2 2003/03/10 06:09:00 demond Exp $
  */
 
 #ifndef INCLUDED_client_h
@@ -50,7 +50,6 @@
 
 #define CLIENT_BUFSIZE 512      /* must be at least 512 bytes */
 
-
 /*
  * pre declare structs
  */
@@ -61,6 +60,47 @@
 struct Client;
 struct LocalUser;
 
+struct Repeat
+{
+	struct Channel *chptr;		/* last phrase block */
+	char *text;
+	time_t lastphrase;
+};
+
+struct SLink;
+struct Watch;
+
+typedef struct Client 	aClient;
+typedef struct Channel 	aChannel;
+typedef struct ConfItem aConfItem;
+typedef struct Watch 	aWatch;
+typedef struct Ban 		aBan;
+
+typedef struct SLink Link;
+
+struct SLink
+{
+    struct SLink	*next;
+    union
+    {
+		aClient		*cptr;
+		aChannel	*chptr;
+		aConfItem	*aconf;
+		aBan		*banptr;
+		aWatch		*wptr;
+		char		*cp;
+    } value;
+    int				flags;
+};
+
+struct Watch
+{
+    aWatch	*hnext;
+    time_t	lasttime;
+    Link	*watch;
+    char	nick[1];
+};
+
 /*
  * Client structures
  */
@@ -68,19 +108,21 @@
 {
   dlink_list     channel;       /* chain of channel pointer blocks */
   dlink_list     invited;       /* chain of invite pointer blocks */
+  dlink_list	 repeat;		/* chain of last phrases per channel blocks */
   char*          away;          /* pointer to away message */
   time_t         last_away;     /* Away since... */
   time_t         last;
   int            refcnt;        /* Number of times this block is referenced */
   int            joined;        /* number of channels joined */
   const char*    server;        /* pointer to scached server name */
-  char*          response;  /* expected response from client */
-  char*          auth_oper; /* Operator to become if they supply the response.*/
-	/* client ID, unique ID per client */
+  char*          response;  	/* expected response from client */
+  char*          auth_oper; 	/* Operator to become if they supply the response.*/
+  /* client ID, unique ID per client */
   char id[IDLEN + 1];
   char id_key[IDLEN + 1];
   /* When did we detach from them, if they are detached... */
-  time_t            last_detach_time;
+  time_t         last_detach_time;
+  int            known;			/* USER came from particular type of client */
 };
 
 struct Server
@@ -127,7 +169,7 @@
   struct Client*    prev;
   struct Client*    hnext;
   struct Client*    idhnext;
-	
+
   struct Client*    lnext;      /* Used for Server->servers/users */
   struct Client*    lprev;      /* Used for Server->servers/users */
 
@@ -144,34 +186,35 @@
   unsigned int      umodes;     /* opers, normal users subset */
   unsigned int      flags;      /* client flags */
   unsigned int      flags2;     /* ugh. overflow */
+  unsigned int      svsflags;   /* services flags */
 
   int               slink_pid;  /* pid of servlink process if any */
   int               hopcount;   /* number of servers to this 0 = local */
-  int		    hidden_server;
+  int		    	hidden_server;
   unsigned short    status;     /* Client type */
   unsigned char     handler;    /* Handler index */
-  char              eob;	/* server eob has been received */
-  unsigned long     serial;	/* used to enforce 1 send per nick */
+  char              eob;		/* server eob has been received */
+  unsigned long     serial;		/* used to enforce 1 send per nick */
   unsigned long     lazyLinkClientExists; /* This client exists on the
-					   * bit mapped lazylink servers 
+					   * bit mapped lazylink servers
 					   * mapped here
 					   */
   /*
    * client->name is the unique name for a client nick or host
    */
-  char              name[HOSTLEN + 1]; 
+  char              name[HOSTLEN + 1];
   /*
    * client->llname is used to store the clients requested nick
    * temporarily for new connections.
    */
   char              llname[NICKLEN];
-  /* 
-   * client->username is the username from ident or the USER message, 
-   * If the client is idented the USER message is ignored, otherwise 
-   * the username part of the USER message is put here prefixed with a 
+  /*
+   * client->username is the username from ident or the USER message,
+   * If the client is idented the USER message is ignored, otherwise
+   * the username part of the USER message is put here prefixed with a
    * tilde depending on the I:line, Once a client has registered, this
    * field should be considered read-only.
-   */ 
+   */
   char              username[USERLEN + 1]; /* client's username */
   /*
    * client->host contains the resolved name or ip address
@@ -181,27 +224,38 @@
    */
   char              host[HOSTLEN + 1];     /* client's hostname */
   /*
-   * client->info for unix clients will normally contain the info from the 
+   * this contains client's real host, whereas host[] field
+   * is modified (in register_local_user) to store masked hostname
+   *                                                     -demond
+   */
+  char          	realhost[HOSTLEN + 1];
+  /*
+   * this contains client's IP, sent by CAP_IP-able server
+   *                                                     -demond
+   */
+  char          	ip[HOSTLEN + 1];
+  /*
+   * client->info for unix clients will normally contain the info from the
    * gcos field in /etc/passwd but anything can go here.
    */
   char              info[REALLEN + 1]; /* Free form additional client info */
 
-/* cache table of mappings between top level chan and sub vchan client
- * is on.
- */
-
-  dlink_list      vchan_map;
+  /* cache table of mappings between top level chan and sub vchan client
+   * is on.
+   */
+  dlink_list      	vchan_map;
 
   /* caller ID allow list */
   /* This has to be here, since a client on an on_allow_list could
    * be a remote client. simpler to keep both here.
    */
-  dlink_list	allow_list;	/* clients I'll allow to talk to me */
-  dlink_list	on_allow_list;	/* clients that have =me= on their allow list*/
-  
-  
-  struct LocalUser *localClient;
+  dlink_list		allow_list;		/* clients I'll allow to talk to me */
+  dlink_list		on_allow_list;	/* clients that have =me= on their allow list*/
+
+  Link 				*watch;
+  int 				watches;
 
+  struct LocalUser *localClient;
 };
 
 struct LocalUser
@@ -211,13 +265,13 @@
    * (directly connected to *this* server with a socket.
    */
   /* Anti flooding part, all because of lamers... */
-  time_t            last_join_time;   /* when this client last 
+  time_t            last_join_time;   /* when this client last
                                          joined a channel */
-  time_t            last_leave_time;  /* when this client last 
+  time_t            last_leave_time;  /* when this client last
                                        * left a channel */
-  int               join_leave_count; /* count of JOIN/LEAVE in less than 
+  int               join_leave_count; /* count of JOIN/LEAVE in less than
                                          MIN_JOIN_LEAVE_TIME seconds */
-  int               oper_warn_count_down; /* warn opers of this possible 
+  int               oper_warn_count_down; /* warn opers of this possible
                                           spambot every time this gets to 0 */
   time_t            last_caller_id_time;
   time_t            first_received_message_time;
@@ -231,10 +285,10 @@
    * we want to use unsigned int here so the sizes have a better chance of
    * staying the same on 64 bit machines. The current trend is to use
    * I32LP64, (32 bit ints, 64 bit longs and pointers) and since ircd
-   * will NEVER run on an operating system where ints are less than 32 bits, 
+   * will NEVER run on an operating system where ints are less than 32 bits,
    * it's a relatively safe bet to use ints. Since right shift operations are
-   * performed on these, it's not safe to allow them to become negative, 
-   * which is possible for long running server connections. Unsigned values 
+   * performed on these, it's not safe to allow them to become negative,
+   * which is possible for long running server connections. Unsigned values
    * generally overflow gracefully. --Bleep
    */
   unsigned int      sendM;      /* Statistics: protocol messages send */
@@ -250,8 +304,8 @@
 
   struct irc_inaddr ip;
   unsigned short    port;       /* and the remote port# too :-) */
-  int 		    aftype;	/* Makes life easier for DNS res in IPV6 */
-  struct DNSQuery   *dns_query;  /* result returned from resolver query */
+  int 		    	aftype;		/* Makes life easier for DNS res in IPV6 */
+  struct DNSQuery   *dns_query;	/* result returned from resolver query */
   unsigned long     serverMask; /* Only used for Lazy Links */
   time_t            last_nick_change;
   int               number_of_nick_changes;
@@ -260,7 +314,7 @@
    * string, this field should be considered read-only once the connection
    * has been made. (set in s_bsd.c only)
    */
-  char              sockhost[HOSTIPLEN + 1]; /* This is the host name from the 
+  char              sockhost[HOSTIPLEN + 1]; /* This is the host name from the
                                               socket ip address as string */
   /*
    * XXX - there is no reason to save this, it should be checked when it's
@@ -303,12 +357,11 @@
    * to avoid flooding.
    *   -- adrian
    */
-  int allow_read;	/* how many we're allowed to read in this second */
+  int allow_read;		/* how many we're allowed to read in this second */
   int actually_read;    /* how many we've actually read in this second */
   int sent_parsed;      /* how many messages we've parsed in this second */
   time_t last_knock;    /* time of last knock */
   unsigned long random_ping;
-
 };
 
 /*
@@ -337,25 +390,26 @@
 
 #define IsOper(x)		((x)->umodes & FLAGS_OPER)
 #define IsAdmin(x)		((x)->umodes & FLAGS_ADMIN)
+#define IsSSLaccept(x)	((x)->umodes & FLAGS_SSLACCEPT)
 
 #define SetConnecting(x)        {(x)->status = STAT_CONNECTING; \
-				 (x)->handler = UNREGISTERED_HANDLER; }
+				 				(x)->handler = UNREGISTERED_HANDLER; }
 
 #define SetHandshake(x)         {(x)->status = STAT_HANDSHAKE; \
-				 (x)->handler = UNREGISTERED_HANDLER; }
+				 				(x)->handler = UNREGISTERED_HANDLER; }
 
 #define SetMe(x)                {(x)->status = STAT_ME; \
-				 (x)->handler = UNREGISTERED_HANDLER; }
+				 				(x)->handler = UNREGISTERED_HANDLER; }
 
 #define SetUnknown(x)           {(x)->status = STAT_UNKNOWN; \
-				 (x)->handler = UNREGISTERED_HANDLER; }
+				 				(x)->handler = UNREGISTERED_HANDLER; }
 
 #define SetServer(x)            {(x)->status = STAT_SERVER; \
-				 (x)->handler = SERVER_HANDLER; }
+				 				(x)->handler = SERVER_HANDLER; }
 
 #define SetClient(x)            {(x)->status = STAT_CLIENT; \
-				 (x)->handler = IsOper((x)) ? \
-					OPER_HANDLER : CLIENT_HANDLER; }
+				 				(x)->handler = IsOper((x)) ? \
+								OPER_HANDLER : CLIENT_HANDLER; }
 
 #define STAT_CLIENT_PARSE (STAT_UNKNOWN | STAT_CLIENT)
 #define STAT_SERVER_PARSE (STAT_CONNECTING | STAT_HANDSHAKE | STAT_SERVER)
@@ -378,9 +432,7 @@
 #define TS_DOESTS       0x20000000
 #define DoesTS(x)       ((x)->tsinfo == TS_DOESTS)
 
-
 /* housekeeping flags */
-
 #define FLAGS_PINGSENT     0x0001 /* Unreplied ping sent */
 #define FLAGS_DEADSOCKET   0x0002 /* Local socket is dead--Exiting soon */
 #define FLAGS_KILLED       0x0004 /* Prevents "QUIT" from being sent for this*/
@@ -395,10 +447,10 @@
 #define FLAGS_CRYPTOUT     0x4000 /* outgoing data must be encrypted */
 #define FLAGS_WAITAUTH     0x8000 /* waiting for CRYPTLINK AUTH command */
 #define FLAGS_SERVLINK     0x10000 /* servlink has servlink process */
-#define FLAGS_MARK	   0x20000 /* marked client */
+#define FLAGS_MARK	   	   0x20000 /* marked client */
 #define FLAGS_CANFLOOD	   0x40000 /* client has the ability to flood */
-/* umodes, settable flags */
 
+/* umodes, settable flags */
 #define FLAGS_SERVNOTICE   0x0001 /* server notices such as kill */
 #define FLAGS_CCONN        0x0002 /* Client Connections */
 #define FLAGS_REJ          0x0004 /* Bot Rejections */
@@ -412,22 +464,30 @@
 #define FLAGS_INVISIBLE    0x0400 /* makes user invisible */
 #define FLAGS_BOTS         0x0800 /* shows bots */
 #define FLAGS_EXTERNAL     0x1000 /* show servers introduced and splitting */
+#define FLAGS_REMOTE       0x2000 /* Remote client registering */
 #define FLAGS_CALLERID     0x4000 /* block unless caller id's */
 #define FLAGS_UNAUTH       0x8000 /* show unauth connects here */
 #define FLAGS_LOCOPS       0x10000 /* show locops */
+#define FLAGS_TRANSWIN     0x100000 /* translate cyrillic Windows-1251 */
+#define FLAGS_TRANSISO     0x200000 /* translate cyrillic ISO-8859-5 */
+#define FLAGS_REGACCEPT    0x400000 /* accepting from reg nicks only */
+#define FLAGS_ALTLOCALE    0x800000 /* receiving numeric replies in alt textdomain */
 
 /* user information flags, only settable by remote mode or local oper */
 #define FLAGS_OPER         0x20000 /* Operator */
 #define FLAGS_ADMIN        0x40000 /* Admin on server */
+#define FLAGS_SSLACCEPT    0x80000 /* accepting from SSL-connected clients only */
 
 #define FLAGS_ALL	   FLAGS_SERVNOTICE
 
+#define FLAGS_SVS_IDENT    0x0001  /* client has identified with services */
+#define FLAGS_SVS_ADMIN    0x0002  /* client has identified as services admin */
 
 /* overflow flags */
 #define FLAGS2_EXEMPTGLINE  0x0001	/* client can't be G-lined */
-#define FLAGS2_EXEMPTKLINE  0x0002      /* client is exempt from kline */
-#define FLAGS2_NOLIMIT      0x0004      /* client is exempt from limits */
-#define FLAGS2_RESTRICTED   0x0008      /* client cannot op others */
+#define FLAGS2_EXEMPTKLINE  0x0002  /* client is exempt from kline */
+#define FLAGS2_NOLIMIT      0x0004  /* client is exempt from limits */
+#define FLAGS2_RESTRICTED   0x0008  /* client cannot op others */
 
 /* oper priv flags */
 #define FLAGS2_OPER_GLOBAL_KILL 0x0020  /* oper can global kill */
@@ -449,20 +509,20 @@
                                  FLAGS2_OPER_REHASH| \
                                  FLAGS2_OPER_ADMIN)
 
-#define FLAGS2_CBURST		0x10000  /* connection burst being sent */
-#define FLAGS2_PING_COOKIE	0x20000		/* PING Cookie */
+#define FLAGS2_CBURST			0x10000  	/* connection burst being sent */
+#define FLAGS2_PING_COOKIE		0x20000		/* PING Cookie */
 #define FLAGS2_IDLE_LINED       0x40000
-#define FLAGS2_IP_SPOOFING      0x80000        /* client IP is spoofed */
-#define FLAGS2_FLOODDONE        0x200000      /* Flood grace period has
-                                               * been ended. */
+#define FLAGS2_IP_SPOOFING      0x80000		/* client IP is spoofed */
+#define FLAGS2_FLOODDONE        0x200000	/* Flood grace period has been ended. */
 
 #define SEND_UMODES  (FLAGS_INVISIBLE | FLAGS_OPER | FLAGS_WALLOP | \
-                      FLAGS_ADMIN)
+                      FLAGS_ADMIN | FLAGS_ALTLOCALE | FLAGS_SSLACCEPT)
 #define ALL_UMODES   (SEND_UMODES | FLAGS_SERVNOTICE | FLAGS_CCONN | \
                       FLAGS_REJ | FLAGS_SKILL | FLAGS_FULL | FLAGS_SPY | \
                       FLAGS_NCHANGE | FLAGS_OPERWALL | FLAGS_DEBUG | \
                       FLAGS_BOTS | FLAGS_EXTERNAL | FLAGS_LOCOPS | \
- 		      FLAGS_ADMIN | FLAGS_UNAUTH | FLAGS_CALLERID)
+ 		      		  FLAGS_REMOTE | FLAGS_UNAUTH | FLAGS_CALLERID | \
+					  FLAGS_TRANSWIN | FLAGS_TRANSISO | FLAGS_REGACCEPT)
 
 #define FLAGS_ID     (FLAGS_NEEDID | FLAGS_GOTID)
 
@@ -474,8 +534,8 @@
 #define IsDead(x)               ((x)->flags & FLAGS_DEADSOCKET)
 #define SetDead(x)              ((x)->flags |= FLAGS_DEADSOCKET)
 #define SetAccess(x)            ((x)->flags |= FLAGS_CHKACCESS)
-#define IsClosing(x)		((x)->flags & FLAGS_CLOSING)
-#define SetClosing(x)		((x)->flags |= FLAGS_CLOSING)
+#define IsClosing(x)			((x)->flags & FLAGS_CLOSING)
+#define SetClosing(x)			((x)->flags |= FLAGS_CLOSING)
 #define ClearAccess(x)          ((x)->flags &= ~FLAGS_CHKACCESS)
 #define IsCryptIn(x)            ((x)->flags &  FLAGS_CRYPTIN)
 #define SetCryptIn(x)           ((x)->flags |= FLAGS_CRYPTIN)
@@ -488,22 +548,33 @@
 #define SetServlink(x)          ((x)->flags |= FLAGS_SERVLINK)
 #define MyConnect(x)            ((x)->localClient != NULL)
 #define MyClient(x)             (MyConnect(x) && IsClient(x))
-#define SetMark(x)		((x)->flags |= FLAGS_MARK)
+#define SetMark(x)			((x)->flags |= FLAGS_MARK)
 #define ClearMark(x)		((x)->flags &= ~FLAGS_MARK)
-#define IsMarked(x)		((x)->flags & FLAGS_MARK)
+#define IsMarked(x)			((x)->flags & FLAGS_MARK)
 #define SetCanFlood(x)		((x)->flags |= FLAGS_CANFLOOD)
 #define ClearCanFlood(x)	((x)->flags &= FLAGS_CANFLOOD)
 #define IsCanFlood(x)		((x)->flags & FLAGS_CANFLOOD)
+#define SendRemoteNotice(x)		((x)->umodes & FLAGS_REMOTE)
+#define SetTransWin(x)          ((x)->umodes |= FLAGS_TRANSWIN)
+#define IsSetTransWin(x)        ((x)->umodes & FLAGS_TRANSWIN)
+#define SetTransISO(x)          ((x)->umodes |= FLAGS_TRANSISO)
+#define IsSetTransISO(x)        ((x)->umodes & FLAGS_TRANSISO)
+#define SetRegAccept(x)         ((x)->umodes |= FLAGS_REGACCEPT)
+#define IsSetRegAccept(x)       ((x)->umodes & FLAGS_REGACCEPT)
+#define SetSSLaccept(x)         ((x)->umodes |= FLAGS_SSLACCEPT)
+#define IsSetSSLaccept(x)       ((x)->umodes & FLAGS_SSLACCEPT)
+#define SetAltLocale(x)         ((x)->umodes |= FLAGS_ALTLOCALE)
+#define IsSetAltLocale(x)       ((x)->umodes & FLAGS_ALTLOCALE)
 
 /* oper flags */
 #define MyOper(x)               (MyConnect(x) && IsOper(x))
 
 #define SetOper(x)              {(x)->umodes |= FLAGS_OPER; \
-				 if (!IsServer((x))) (x)->handler = OPER_HANDLER;}
+				 				if (!IsServer((x))) (x)->handler = OPER_HANDLER;}
 
 #define ClearOper(x)            {(x)->umodes &= ~(FLAGS_OPER|FLAGS_ADMIN); \
-				 if (!IsOper((x)) && !IsServer((x))) \
-				  (x)->handler = CLIENT_HANDLER; }
+				 				if (!IsOper((x)) && !IsServer((x))) \
+				  				(x)->handler = CLIENT_HANDLER; }
 
 #define IsPrivileged(x)         (IsOper(x) || IsServer(x))
 
@@ -524,8 +595,8 @@
 #define SendDebugNotice(x)      ((x)->umodes & FLAGS_DEBUG)
 #define SendNickChange(x)       ((x)->umodes & FLAGS_NCHANGE)
 #define SetWallops(x)           ((x)->umodes |= FLAGS_WALLOP)
-#define SetCallerId(x)		((x)->umodes |= FLAGS_CALLERID)
-#define IsSetCallerId(x)	((x)->umodes & FLAGS_CALLERID)
+#define SetCallerId(x)			((x)->umodes |= FLAGS_CALLERID)
+#define IsSetCallerId(x)		((x)->umodes & FLAGS_CALLERID)
 
 #define SetIpHash(x)            ((x)->flags |= FLAGS_IPHASH)
 #define ClearIpHash(x)          ((x)->flags &= ~FLAGS_IPHASH)
@@ -592,11 +663,11 @@
 extern void           free_client(struct Client* client);
 extern void           add_client_to_list(struct Client* client);
 extern void           remove_client_from_list(struct Client *);
-extern void           add_client_to_llist(struct Client** list, 
+extern void           add_client_to_llist(struct Client** list,
                                           struct Client* client);
-extern void           del_client_from_llist(struct Client** list, 
+extern void           del_client_from_llist(struct Client** list,
                                             struct Client* client);
-extern int            exit_client(struct Client*, struct Client*, 
+extern int            exit_client(struct Client*, struct Client*,
                                   struct Client*, const char*);
 
 
@@ -616,5 +687,17 @@
                              char *nick);
 extern void dead_link(struct Client *client_p);
 extern void exit_aborted_clients(void);
-#endif /* INCLUDED_client_h */
+extern char *translate(struct Client *client_p, char *buf);
+
+#define MAXWATCH		128
+#define WATCHHASHSIZE	U_MAX/16	/* reasonable for bnet i think... -demond */
+
+extern void 	  count_watch_memory(int *, u_long *);
+extern void    	  clear_watch_hash_table(void);
+extern int     	  add_to_watch_hash_table(char *, aClient *);
+extern int     	  del_from_watch_hash_table(char *, aClient *);
+extern int     	  hash_check_watch(aClient *, int);
+extern int     	  hash_del_watch_list(aClient  *);
+extern aWatch 	 *hash_get_watch(char *);
 
+#endif /* INCLUDED_client_h */
diff -uNrd -x CVS ircd-hybrid-7rc5/include/common.h ircd-hybrid-7-bg/include/common.h
--- ircd-hybrid-7rc5/include/common.h	Sat Jan  5 04:14:27 2002
+++ ircd-hybrid-7-bg/include/common.h	Mon Dec 30 23:07:25 2002
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: common.h,v 7.3 2002/01/05 09:14:27 a1kmm Exp $
+ *  $Id: common.h,v 1.1.1.1 2002/12/31 04:07:25 demond Exp $
  */
 
 #ifndef INCLUDED_common_h
diff -uNrd -x CVS ircd-hybrid-7rc5/include/config.h ircd-hybrid-7-bg/include/config.h
--- ircd-hybrid-7rc5/include/config.h	Tue Jul  9 20:05:51 2002
+++ ircd-hybrid-7-bg/include/config.h	Sat May 24 23:27:09 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: config.h,v 7.140 2002/07/10 00:05:51 leeh Exp $
+ *  $Id: config.h,v 1.6 2003/05/25 01:31:33 demond Exp $
  */
 
 #ifndef INCLUDED_config_h
@@ -299,6 +299,8 @@
 #define VCHANS
 #define ANONOPS
 #define HALFOPS
+#define USEPACE
+#undef UMODEQ
 
 /* END OF CONFIGURABLE OPTIONS */
 
@@ -307,6 +309,8 @@
 #undef VCHANS
 #undef ANONOPS
 #undef HALFOPS
+#undef USEPACE
+#undef UMODEQ
 #ifndef HIDE_SERVERS_IPS
 #define HIDE_SERVERS_IPS
 #endif
